searchNodes=[{"ref":"Quantity.html","title":"Quantity","type":"module","doc":"A data structure that encapsulates a decimal value with a unit."},{"ref":"Quantity.html#base_value/1","title":"Quantity.base_value/1","type":"function","doc":"Extracts the base value from the quantity"},{"ref":"Quantity.html#exponent/1","title":"Quantity.exponent/1","type":"function","doc":"Extracts the exponent from the quantity"},{"ref":"Quantity.html#new/2","title":"Quantity.new/2","type":"function","doc":"Builds a new Quantity from a Decimal and a unit"},{"ref":"Quantity.html#new/3","title":"Quantity.new/3","type":"function","doc":"Builds a new Quantity from a base value, exponent and unit"},{"ref":"Quantity.html#parse/1","title":"Quantity.parse/1","type":"function","doc":"Parses a string representation of a quantity (perhaps generated with to_string/1)"},{"ref":"Quantity.html#parse!/1","title":"Quantity.parse!/1","type":"function","doc":"Same as parse/1, but errors if it could not parse"},{"ref":"Quantity.html#to_string/1","title":"Quantity.to_string/1","type":"function","doc":"Encodes the quantity as a string. The result is parsable with parse/1 If the exponent is positive, encode usinge the &quot;raw&quot; format to preserve precision iex&gt; Quantity.new(42, -1, &quot;db&quot;) |&gt; Quantity.to_string() &quot;4.2 db&quot; iex&gt; Quantity.new(42, 1, &quot;db&quot;) |&gt; Quantity.to_string() &quot;42E1 db&quot;"},{"ref":"Quantity.html#unit/1","title":"Quantity.unit/1","type":"function","doc":"Extracts the unit from the quantity"},{"ref":"Quantity.html#t:t/0","title":"Quantity.t/0","type":"type","doc":""},{"ref":"Quantity.Sigils.html","title":"Quantity.Sigils","type":"module","doc":"Sigils related to Quantity and Decimal"},{"ref":"Quantity.Sigils.html#sigil_Q/2","title":"Quantity.Sigils.sigil_Q/2","type":"function","doc":"Construct a Quantity iex&gt; ~Q[12.340 kwh] Quantity.new(~d[12.340], &quot;kwh&quot;)"},{"ref":"Quantity.Sigils.html#sigil_d/2","title":"Quantity.Sigils.sigil_d/2","type":"function","doc":"Construct a Decimal iex&gt; ~d[12.340] Decimal.new(&quot;12.340&quot;)"},{"ref":"readme.html","title":"Quantity","type":"extras","doc":"Quantity A Quantity is an Elixir data structure that encapsulates values with units. This data structure can be used to carry values and units through calculations using the calculation functions in the Quantity library."},{"ref":"readme.html#usage","title":"Quantity - Usage","type":"extras","doc":"Creating Quantities A Quantity can be created in several ways, one is Quantity.parse/1 or Quantity.parse!/1, which parses a Quantity from a string: Quantity.parse(&quot;200.345 EUR&quot;) # {:ok, ~Q[200.345 EUR]} Quantity.parse!(&quot;200.345 EUR&quot;) # ~Q[200.345 EUR] The Quantity module also has new/2 which creates a Quantity from a Decimal.t() and a String.t(): Quantity.new(Decimal.new(&quot;300.445&quot;), &quot;km&quot;) # ~Q[300.445 km] And lastly a Quantity can be created from a value, an exponent and a unit: Quantity.new(6578, -2, &quot;seconds&quot;) # ~Q[65.78 seconds] The ~Q and ~d sigils Quantity has a special sigil_Q/2 sigil, as seen above. Quantities can be created using the ~Q sigil, and they are printed as ~Q when inspected. import Quantity.Sigils, only: [sigil_Q: 2] ~Q[500 bananas] # ~Q[500 bananas] Additionally a sigil_d/2 sigil is also present to easily create decimals: import Quantity.Sigils, only: [sigil_d: 2] ~d[123.456] #Decimal&lt;123.456&gt; Data structure Underneath, a Quantity is simply a map consisting of value and unit, where value is a Decimal.t() and unit a String.t(): ~Q[99 problems] |&gt; IO.inspect(structs: false) %{ __struct__: Quantity, unit: &quot;problems&quot;, value: %{__struct__: Decimal, coef: 99, exp: 0, sign: 1} }"},{"ref":"readme.html#installation","title":"Quantity - Installation","type":"extras","doc":"The package is only available on GitHub at the moment, it can be added to mix.exs using: def deps do [ # Add Quantity from GitHub {:quantity, git: &quot;https://github.com/wise-home/quantity.git&quot;, tag: &quot;0.1.0&quot;} ] end"}]